#include        <ultra64.h>

#include        "thread.h"
#include "textlib.h"
#include "cont.h"

//-----------------
// Externals
extern u16      *bitmap_buf;
extern u16      bitmap_buf1[];
extern u16      bitmap_buf2[];

extern u8 backup_buffer[];
extern  s32 __osDumpInode(OSPfs *);
extern s32 __osDumpId(OSPfs *);
extern OSMesgQueue retraceMessageQ;

//-----------------
// Headers
void fail(void);
int UI_EditName(char *name);
void PfsReadPaks(int pattern);
char ConvertPfsChar(char c);
char ConvertAsciiChar(char c);
int GetButton(void);

//char *strncpy (char *dest, char *source, int count);
int strncmp (const char * first, const char * last, int count);
char *strcpy (char *dest, const char *source);

//-----------------
// Global variables
u8 long_buffer[EEPROM_MAXBLOCKS * EEPROM_BLOCK_SIZE];

OSPfs pfs0;

#define NUM_MESSAGE 1

static int err_handlaer(int, OSPfs *);

OSMesgQueue  pifMesgQueue;
OSMesg       pifMesgBuf[NUM_MESSAGE];
OSContPad       **pad;
u16 button,last_button;
//char SRAM[5] = {'S'-0x27,'R'-0x27,'A'-0x27,'M'-0x27,0};
char symbol[14]="!\"#'*+,-./:=?@";
//char AnyButton[]="\tPress any button to continue";

char saveName[17];
char PfsSaveName[17];

OSPfsState AllStates[MAXCONTROLLERS*16];


/****************************************************************
		 Add some routine for ds1 test
****************************************************************/
unsigned long sram_buffer[0x2000];      // 32k sram_buffer
unsigned long hi_word;
unsigned int i;
char *ds1Header="DS1_Manager";
char *fileNameList[7];
char sramFileName[6][20];               // for 6 bank file name
char *fileName;
unsigned long baseAdr;

char *str_buf="";

void waitKeyB(void)
{
   set_xy(0,24);
   setcolor(200,100,0);          // set front color
   draw_center("Press Button-B to return");
//   GetButton();                       // wait any button press
   while(1){
      pad=ReadController(B_BUTTON);
      if (pad==0)
	 button=0;
      else
	 button=pad[0]->button | pad[1]->button | pad[2]->button | pad[3]->button;
      osWritebackDCacheAll();           // Delay
      if (button==B_BUTTON) return;
   }
}

int waitKeyStart(void)
{
   set_xy(0,24);
//   setcolor(255,50,50);          // set front color
   draw_center("     =Accept, any Button=Cancel");
   set_xy(4,24);
   setcolor(255,50,50);          // set front color
   draw_puts("Start");
//   GetButton();                       // wait any button press
   while(1){
      pad=ReadController(0xffff);
      if (pad==0)
	 button=0;
      else
	 button=pad[0]->button | pad[1]->button | pad[2]->button | pad[3]->button;
      osWritebackDCacheAll();           // Delay
      if (button==0) continue;
      if (button==START_BUTTON) 
	return (1);
      else
	return (0);
   }
}

void writePI(unsigned long addr, unsigned long value)
{
	do {} while (*(volatile unsigned long *) (0xa4600010) & 3);     // check parallel interface not busy
	addr &=0xbffffffc;
	*(unsigned long *)(addr)=value;
}

unsigned long readPI(unsigned long addr)
{
	do {} while (*(volatile unsigned long *) (0xa4600010) & 3);     // check parallel interface not busy
	addr &=0xbffffffc;
	return *(unsigned long *)(addr);
}

unsigned char read_verify_sram(unsigned char mode,unsigned int length)
{
   if (mode){
      for (i=0;i<length;i++){
	 sram_buffer[i]=readPI(hi_word|(i<<2)); // read data to sram_buffer
      }
   }
   else{
      for (i=0;i<length;i++){
	 if (sram_buffer[i]!=readPI(hi_word|(i<<2))){   // verify data with bufferx
//            sprintf(str_buf,"\tverify error at %x\n",(i<<2));
//          draw_puts(str_buf);
	    return(1);
	 }
      }
   }
   return(0);
}

void write_sram(void)           // ******
{
   for (i=0;i<0x2000;i++){              // 0x4000 word=0x8000 byte
      writePI((hi_word + (i<<2)),sram_buffer[i]);       // write data from bufferx
   }
}

void sram_pat_gen(unsigned long base)
{
   for (i=0;i<0x4000;i+=2){
      sram_buffer[i>>1]=((i+base)<<16) | (((i+1) + base) & 0xffff);     // sram_buffer is 0x2000 unsigned long
   }
}


int check_sram(void)
{
   int j;
   clear_lines(19,1);
   set_xy(0,19);
   setcolor(100,100,100);          // set front color
   draw_puts("\tVerify Pattern From DS1 ");
   for (j=0;j<8;j++){           // fill pattern to all bank
      hi_word=0xa8000000 + 0x8000*j;
      sram_pat_gen(j);
      draw_puts("v");
      if (read_verify_sram(0,0x2000)){
	 break;
      }
   }

   draw_puts("\n\n");
   if (j==8){
      draw_center("Memory Test Ok");
      return(0);
   }
   else
      draw_center("Verify pattern error");
   return(1);                   // error return
}


void writeAllPattern(void)
{
int j;
   clear_lines(18,6);
   set_xy(0,18);
   setcolor(100,100,100);          // set front color
   draw_puts("\tWrite Pattern to DS1 ");
   for (j=0;j<8;j++){           // fill pattern to all bank
       hi_word=0xa8000000 + 0x8000*j;
       sram_pat_gen(j);
       draw_puts("w");
       write_sram();
   }
}

void test_sram(void)
{
//   int i,j;
   if(!waitKeyStart()) return;
   clear_lines(5,2);
   clear_lines(12,(30-12));                  // clear display area line12~29
   set_xy(0,16);
   setcolor(100,100,200);
   draw_center ("Memory Test\n");
//waitKeyB();
//return;
   sram_pat_gen(0);             // generate test pattern
   hi_word=0xa8000000;          // bank 0 starting address
   if (read_verify_sram(0,0x2000)){             //verify error
      writeAllPattern();
      check_sram();
   }
   else{
//      draw_puts("\tVerify Pattern From DS1 ");
      if (check_sram()){
	 writeAllPattern();     // write all pattern
	 check_sram();          // check all pattern
      }
   }
   waitKeyB();          // wait press any Button to return
}




void fillBlankName(char **list) // try to learn pointer property
{
//char *blankName="blankName";  // fill 6 bank is "Blank"
//char *s;
for (i=0;i<6;i++)
//   *list++=blankName;
   list[i]="Blank";
//*list=0;
//list[6]=s;
list[6]=0;
}



int checkHeader(void)   // at the 8th bank of 32k
{
   int j;
   char temp_str[16];
   unsigned long temp;

   for (i=0;i<4;i++){
      temp=readPI(baseAdr + (i<<2)); // read data to sram_buffer
      for (j=0;j<4;j++){
	 temp_str[i*4+j]=(char)((temp>>(8*(3-j))) & 0xff);
      }
   }

   for (i=0;i<strlen(ds1Header);i++)
      if (ds1Header[i]!=temp_str[i])
	  break;
      
   if (i==strlen(ds1Header))
      return(0);                // header ok
   else
      return(1);                // header error
}



void packFileName(char **list)  // pack 6 file to list
{
int i;
   for (i=0;i<6;i++)
   *list++=sramFileName[i];
}

void dispAllFileName (char **itemList, int x, int y) {
// Display menu
   setcolor(80,80,80);
   for ( i=0 ; i<6 ; i++) {
      set_xy (x,i+y);
      draw_puts (itemList[i]);
   }
}


int writeBank(int bank)
{
   hi_word=0xa8000000;          // point to buffer area
   read_verify_sram(1,0x2000);  //read data to 32k buffer
   if (read_verify_sram(0,0x2000)){     //verify data
      draw_center("process error at read");
      return(-1);
   }
   hi_word=hi_word + ((bank+1)*0x8000);         // cal. bank address
   write_sram();                // write data to bank
   if (read_verify_sram(0,0x2000)){     //verify data
      draw_center("process error at verify");
      return(-1);
   }
   else
      draw_center("Backup Data ok");
   return(0);
}

int readBank(int bank)
{
   hi_word=hi_word + ((bank+1)*0x8000);         // cal. bank address
   read_verify_sram(1,0x2000);  //read data to 32k buffer
   if (read_verify_sram(0,0x2000)){     //verify data
      draw_center("process error at read");
      return(-1);
   }
   hi_word=0xa8000000;          // point to buffer area
   write_sram();                // write data to bank
   if (read_verify_sram(0,0x2000)){     //verify data
      draw_center("process error at verify");
      return(-1);
   }
   else
      draw_center("Restor Data ok");
   return(0);
}




void writeFileName(char **list)         // write to sram file name area
{
unsigned long temp;
int j;
char *s;
char allFileName[20*6];
   j=0;
   allFileName[0]=0;
   for (i=0;i<6;i++){
      s=list[i];
      while(*s){
	 allFileName[j++]=*s++;
      }
      allFileName[j++]=0;
   }
   for (i=0;i<(20*6)/4;i++){    // write to sram file name area
      temp=0;
      for (j=0;j<4;j++)
	 temp=(allFileName[i*4+j]) + (temp<<8);
      writePI(baseAdr + (i<<2) + 0x10,temp); 
   }
}

void readFileName(void)         // read file name from sram area
{
int j,k;
//char temp_str[20];
unsigned long temp;
char allFileName[20*6];
   for (i=0;i<(20*6)/4;i++){
      temp=readPI(baseAdr + (i<<2) + 0x10); // read file name from sram area
      for (j=0;j<4;j++){
	 allFileName[i*4+j]=(char)((temp>>(8*(3-j))) & 0xff);
      }
   }
   j=0;
   for (i=0;i<6;i++){
      k=0;
      while(allFileName[j]){
	 sramFileName[i][k++]=allFileName[j++];
      }
      j++;
      sramFileName[i][k]=0;
   }
}



void findDs1Dir(void)   // at the 8th bank of 32k
{
int j;
//char temp_str[16];
unsigned long temp;
   if (checkHeader()){                  // check header present
      for (i=0;i<4;i++){                // write header to sram
	 temp=0;
	 for (j=0;j<4;j++)
	     temp=(ds1Header[i*4+j]) | (temp<<8);
	 writePI(baseAdr + (i<<2),temp); // write data to sram
      }
      fillBlankName(fileNameList);      // fill 6 blank is "Blank"
      writeFileName(fileNameList);      // write file name to sram
//waitKeyB();
   }
   if (checkHeader()) {                 // check header again
      set_xy(0,20);
      setcolor(255,100,100);
      draw_center("DS1 something error!");
      for(;;);                          // dead loop
   }
//   readFileName(fileNameList);                // read file name from sram
   readFileName();                      // read 6 file from sram area
}


void backupData(void)
{
int bankNo;
char editFile[20];
baseAdr=0xa8038000;                     // last bank of 32k
   findDs1Dir();
   packFileName(fileNameList);          // pack 6 file to fileNameList
   set_xy(0,12);
   draw_center("Up/Down to select, A=Accept, B=Cancel");
   bankNo=menu(fileNameList,4,13);
   if (bankNo==-1) return;
   clear_lines(12,1);                   // clear select msg
   strcpy(editFile,sramFileName[bankNo]);
   if (UI_EditName(editFile)==0)        // edit file name
      strcpy(sramFileName[bankNo],editFile);
   else
      return;                           // abort edit and backup
   clear_lines(19,(30-19));             // clear edit msg

   set_xy(0,21);
   if (writeBank(bankNo)==0){
      packFileName(fileNameList);               // pack 6 file to fileNameList
      writeFileName(fileNameList);      // write file name to sram
      dispAllFileName(fileNameList,4,13);
   }
   waitKeyB();          // wait press any Button to return
}


void restoreData(void)
{
int bankNo;
baseAdr=0xa8038000;                     // last bank of 32k
   if (checkHeader()){
      set_xy(0,14);
      draw_center("no data in DS1!");
      waitKeyB();
      return;
   }
//   findDs1Dir();
   readFileName();
   packFileName(fileNameList);          // pack 6 file to fileNameList
   set_xy(0,12);
   draw_center("Up/Down to select, A=Accept, B=Cancel");
   bankNo=menu(fileNameList,4,13);
   clear_lines(12,1);                   // clear select msg
   if (bankNo==-1) return;
   clear_lines(19,(30-19));             // clear edit msg
   set_xy(0,21);
   readBank(bankNo);
   waitKeyB();          // wait press any Button to return

}



void dump_128Data(void)
{
   hi_word=0xa8000000;                  // point to working area
   read_verify_sram(1,0x2000);  //read data to 32k buffer
   set_xy(0,13);
   draw_puts("   ");
   for (i=0;i<(128/4);i++){
      if ((i&3)==0) draw_puts("\n   ");
      draw_uint(sram_buffer[i]);
      draw_puts(" ");
   }
   waitKeyB();
}



/*-------------------------
MAIN -- START OF USER CODE
--------------------------*/
void mainproc(void *arg) {
	int i;
	u8 p;
//        int num_paks=0;
	u32 eep;
	char memoryStr[]="Memory Test(all data will be deleted)";
	char backupStr[]="Backup Data";
	char restoreStr[]="Restore Data";
	char dump[]="Dump first 128 Data";
//      char *mainMenu[]={backupStr,restoreStr,memoryStr,dump,0};
	char *mainMenu[]={backupStr,restoreStr,memoryStr,0};


// 0x10 = 0-9, A-Z, !"#'*+,-./:=?@
//      char    teststring[]={'B'-0x27,'U'-0x27,'B'-0x27,'B'-0x27,'A'-0x27,0};
//      char bubStr[]="Bubba";

	init_draw();
	initControllers(MAXCONTROLLERS);
	eep = osEepromProbe(&pifMesgQueue);
	setcolor(255,255,255);          // set front color
	set_xy(0,2);
//      draw_center("Scanning");
	osPfsIsPlug(&pifMesgQueue, &p);
	PfsReadPaks(p);

 while (1) {
// Display title string
	setcolor(200,200,0);
	set_xy(0,2);
	draw_center("DS1 Manager 1.1");

   osContStartReadData(&pifMesgQueue);



	hi_word=0xa8000000;                  // point to sram address
	read_verify_sram(1,0x2000);          // read 32k from sram
	if (read_verify_sram(0,0x2000)){         // verify 32k from sram
		draw_center("\nDS1 not Found");
		for(;;);                          // dead loop
	}

temp_entry:
	clear_lines(5,(30-5));                  // clear display area line4~29
	set_xy(0,5);
	setcolor(100,100,200);
	draw_center ("Choose A Function\n");
	draw_center("Up/Down to select, A=Accept");

	i=-1;
	while(i==-1){
		i=menu(mainMenu,2,8);
	}
	clear_lines(5,2);                       // clear choose A function... msg
	switch (i){
		case 0:backupData();break;
		case 1:restoreData();break;
		case 2:test_sram();break;
		case 3:dump_128Data();break;
//                defaults : break;
	}

goto temp_entry;


	clear_draw();
	osRecvMesg(&pifMesgQueue,(OSMesg)0,OS_MESG_NOBLOCK);  // Clear controller message
 }
}


/*--------------------

---------------------*/
static int
err_handlaer(int error, OSPfs *pfs)
{
	switch(error) {

	case PFS_ERR_NEW_PACK:
		osPfsInit(pfs->queue, pfs, pfs->channel);
		break;

	case PFS_ERR_INCONSISTENT:
		osPfsChecker(&pfs0);
		break;

	default:
		break;
	}
	return(0);
}

/*--------------------

---------------------*/
void fail(void) {
	clear_draw();
	setcolor(255,255,255);
	draw_puts ("\f\n\n\n\tController Pak Error");
	for (;;);
}

/*--------------------

---------------------*/
char *strcpy (char *dest, const char *source) {
   char *start = dest;

	while (*source)
		*dest++ = *source++;
	*dest=0x0;
	return(start);
}

/*--------------------

---------------------*/
int strncmp (const char * first, const char * last, int count) {
	if (!count)
		return(0);

	while (--count && *first && *first == *last)
	{
		first++;
		last++;
	}

	return( *(unsigned char *)first - *(unsigned char *)last );
}

/*--------------------

---------------------*/
int menu (char **itemList, int x, int y) {
	int i,choice=0;
	for ( ;; ) {

// Display menu
		setcolor(80,80,80);
//              draw_puts (itemList[choice]);
		if ( choice > 0) {
			for ( i=0 ; i<choice ; i++) {
				set_xy (x,i+y);
				draw_puts (itemList[i]);
			}
		}
		setcolor(0,220,0);
		set_xy (x,choice+y);
		draw_puts (itemList[choice]);

		i=choice+1;
		setcolor(80,80,80);
		while (itemList[i]) {
			set_xy (x,i+y);
			draw_puts (itemList[i++]);
		}

// Accept input
		pad=ReadController(A_BUTTON|B_BUTTON|U_JPAD|D_JPAD);
//              pad=ReadController(0xffff);
		if (pad==0)
			button=0;
		else
			button=pad[0]->button | pad[1]->button | pad[2]->button | pad[3]->button;
// Process
		if ( button == D_JPAD) {
			choice++;
			if ( itemList[choice]==0)
				choice = 0;
		}

		if (button == U_JPAD) {
			if (choice)
				choice--;
			else {
				while (itemList[choice])
					choice++;
				choice--;
			}
		}

		if (button == A_BUTTON)
			return choice;
		if (button == B_BUTTON)
			return -1;
	}
}




/*--------------------

---------------------*/
char ConvertPfsChar(char c) {
	if (c==0x0F)
		c=' ';
	else if (c < 0x10)
		c='?';
	else if (c < 0x1A)
		c+='0'-0x10;
	else if (c < 0x34)
		c+='A'-0x1A;
	else if (c < 0x42)
		c=symbol[c-0x34];
	else
		c='?';
	return c;
}

/*--------------------

---------------------*/
char ConvertAsciiChar(char c) {
	char *sym;

	if (c==' ')
		c=0x0F;
	else if (c >='0' && c<='9')
		c-='0'-0x10;
	else if (c >='A' && c<='Z')
		c-='A'-0x1A;
	else if (sym=(char *)strchr(symbol,c))
		c=(char)(sym-symbol)+0x34;
	else
		c=0x0F;
	return c;
}


/*--------------------

---------------------*/
int UI_EditName(char *name) {
	int i,disp,xEdit;
	char c;
	char *s;
	int last,count;

	clear_lines(21,29);
	setcolor(200,200,200);
	set_xy(0,23);
	draw_center("JPAD to edit, A=Accept, B=Cancel");

	xEdit=strlen(name);
	if (xEdit==16)
		xEdit--;
	for (i=strlen(name) ; i<16 ; i++)
		name[i]=' ';
	name[16]=0x0;
	disp=1;
	button=-1;

	while (1) {
		if (disp) {
			setcolor(200,200,200);
			set_xy(3,21);
			draw_puts(name);
			setcolor(0,220,0);
			set_xy(xEdit+3,21);
			c=name[xEdit];
			if (c==' ')
				draw_char('_');
			else
				draw_char(name[xEdit]);
//                      osWritebackDCacheAll();                  // Shouldn't be necessary now that we're using it as a delay below
			disp=0;
		}

		pad=ReadController(A_BUTTON|B_BUTTON|L_TRIG|R_TRIG|L_JPAD|R_JPAD);
		osWritebackDCacheAll();                // This isn't actually necessary, it is just a convenient delay to allow the pad to be processed correctly.
		if (pad==0)
			continue;
		last=button;
		button=pad[0]->button | pad[1]->button | pad[2]->button | pad[3]->button;

		switch (button) {
			case A_BUTTON:
				s=name+strlen(name)-1;
				while (*s==' ')
					s--;
				*(s+1)=0x0;
				return 0;
			case B_BUTTON:
				return -1;

			case L_TRIG:
			case L_JPAD:
				if ( xEdit>0)
					xEdit--;
				disp=1;
				count=0;
				break;

			case R_TRIG:
			case R_JPAD:
				if ( xEdit<15)
					xEdit++;
				disp=1;
				count=0;
				break;

			case U_JPAD:
				if (last==button)
					count++;
				else
					count=0;

				if (!CheckUpd(count)) {
					c=ConvertAsciiChar(name[xEdit]);
					if (c==0x41)                      // '@'
						c=0x0E;
					name[xEdit]=ConvertPfsChar(++c);
					disp=1;
				}
				break;

			case D_JPAD:
				if (last==button)
					count++;
				else
					count=0;
				if (!CheckUpd(count)) {
					c=ConvertAsciiChar(name[xEdit]);
					c--;
					if (c < 0x0F)
						c=0x41;
					name[xEdit]=ConvertPfsChar(c);
					disp=1;
				}
		}

	}
}

/*--------------------

---------------------*/
int CheckUpd (int count) {
	if (count==0)
		return 0;
	else if (count < 500)
		return 1;
	else if (count < 1800)
		return count&255;
	else
		return count&127;
}

/*--------------------

---------------------*/
int GetButton(void) {
	osRecvMesg(&pifMesgQueue,(OSMesg)0,OS_MESG_NOBLOCK);  // Clear controller message
	osContStartReadData(&pifMesgQueue);
	osWritebackDCacheAll();              // Delay
	osWritebackDCacheAll();              // Delay

	button=0;
	while (!button) {
		pad=ReadController(0);
		if (pad==0)
			button=0;
		else
			button=pad[0]->button | pad[1]->button | pad[2]->button | pad[3]->button;
		osWritebackDCacheAll();           // Delay
	}

	return button;
}


/*--------------------
 Reads all controller paks
---------------------*/
void PfsReadPaks(int pattern) {
	int i,j;

	for (i=0 ; i<MAXCONTROLLERS ; i++) {
		if (pattern & (1<<i)) {
			if (osPfsInit(&pifMesgQueue, &pfs0, i)) fail;
			for ( j=0 ; j<16 ; j++) {
				if (osPfsFileState(&pfs0,j,&AllStates[i*16+j]))
					AllStates[i*16+j].file_size=0;
			}
		} else
			for ( j=0 ; j<16 ; j++)
					AllStates[i*16+j].file_size=0;
	}
}
