
#include "textlib.h"

extern u16      *bitmap_buf;
extern u16      bitmap_buf1[];

unsigned int x_pos=0;
unsigned int y_pos=0;
unsigned int scroll_top=0;
unsigned int scroll_x=0;
unsigned int scroll_y=0;
extern u8 patterns[NUM_OF_CHAR][PATTERN_SIZE_Y];
u16 color;
u16 bg_color=0;

/*--------------------

---------------------*/
void setcolor( int r, int g, int b)
{
  color = GPACK_RGBA5551(r,g,b,1);
}

/*--------------------

---------------------*/
void setbgcolor( int r, int g, int b)
{
  bg_color = GPACK_RGBA5551(r,g,b,1);
}

/*--------------------

---------------------*/
void init_draw(void)
{
  int mode=RESOLUTION;
  int i;
  u16 *r;
  bitmap_buf = bitmap_buf1;
  clear_draw();
  if(mode == LOW)
    osViSetMode(&osViModeTable[OS_VI_NTSC_LPF1]);
  else
    osViSetMode(&osViModeTable[OS_VI_NTSC_HPF1]);
  osViSwapBuffer( bitmap_buf );

  r = bitmap_buf1;
  for (i = 0; i < SCREEN_SIZE_X * SCREEN_SIZE_Y; i ++)
    *r++  = bg_color;
}

/*--------------------

---------------------*/
void clear_draw(void) {
  int i;
  u16 *r;

  r = bitmap_buf;
  for (i = 0; i < SCREEN_SIZE_X * SCREEN_SIZE_Y; i ++)
    *r++  = bg_color;
}

/*--------------------

---------------------*/
void clear_lines(int line,int count) {
  int i;
  u16 *r;

  r = bitmap_buf+(SCREEN_SIZE_X*PATTERN_SIZE_Y*line);
  for (i = 0; i < SCREEN_SIZE_X * PATTERN_SIZE_Y*count; i ++)
    *r++  = bg_color;
}

/*--------------------

---------------------*/
void set_xy (int x,int y) {
	x_pos = x;
	y_pos = y;
   if( x_pos >= NUM_OF_X )
		x_pos = 0;
	if( y_pos >= NUM_OF_Y )
		y_pos = 0;
}


/*--------------------

---------------------*/
void draw_char( int in_code )
{
  int i,j,k;
  int code;
  switch( in_code )
    {
    case '\n':
      x_pos = 0;
      if( ++y_pos >= NUM_OF_Y )
	{
	  y_pos=0;
	}
      break;
    case '\r':
      x_pos = 0;
      break;
    case '\t':
                   x_pos += 4;
      if( x_pos  >= NUM_OF_X )
	{
	  x_pos = 0;
	  if( ++y_pos >= NUM_OF_Y )
	    {
	      y_pos=0;
	    }
	}
      break;
    case '\f':
      y_pos = 0;
      x_pos = 0;
      break;
    default:

// Map unknown chars to ?
      if( 0 > ( code = in_code - 0x20 ))
	code = 0x1f;
      else if( 0x5f-5 < code)
	code = 0x1f;

      for(i = 0 ; i < PATTERN_SIZE_Y ; i++)  // Char Height Loop
	for(j = 0 ; j < PATTERN_SIZE_X ; j++)  // Char Width loop
	  bitmap_buf[ (y_pos * PATTERN_SIZE_Y + i) * SCREEN_SIZE_X +
		     (x_pos * PATTERN_SIZE_X + j) ]
		       = ( ((patterns[code][i]>>(7-j)) & 0x01)? color:bg_color);

/*
      for(i = k = 0 ; i < PATTERN_SIZE_Y*2 ; i++) { // Char Height Loop
			for(j = 0 ; j < PATTERN_SIZE_X ; j++)  // Char Width loop
		  		bitmap_buf[ (y_pos * PATTERN_SIZE_Y * 2 + i) * SCREEN_SIZE_X + (x_pos * PATTERN_SIZE_X + j) ]
		       = ( ((patterns[code][k]>>(7-j)) & 0x01)? color:bg_color);
			k=i>>1;
		}
*/

// Update cursor pos, wrap if necessary
      if( ++x_pos >= NUM_OF_X )
	{
	  x_pos = 0;
	  if( ++y_pos >= NUM_OF_Y )
	    {
	      y_pos=0;
	    }
	}
      break;
    }
}


/*--------------------

---------------------*/
void draw_uint( unsigned long num )
{
  int i;
  for(i = 0 ; i < 4; i++)
    draw_hex( num >> (8 * (3 - i)) );
}

/*--------------------

---------------------*/
void draw_ushort( unsigned short num )
{
  int i;
  for(i = 0 ; i < 2; i++)
    draw_hex( num >> (8 * (1 - i)) );
}


/*--------------------

---------------------*/
void draw_hex( int num )
{
  int lo,hi;
  lo = num & 0x0f;
  hi = (num >> 4) & 0x0f;
  if(hi >= 10)
    draw_char('a' + hi -10);
  else
    draw_char('0' + hi);
  if(lo >= 10)
    draw_char('a' + lo -10);
  else
    draw_char('0' + lo);

  osWritebackDCacheAll();
}


/*--------------------

---------------------*/
void draw_dec( int num ) {
	char tbuf[11];
	char *c;

	c=tbuf;
	while (num) {
		*c++ = '0'+ num%10;
		num /= 10;
	}

	while (c>tbuf) {
		draw_char(*--c);
	}

	osWritebackDCacheAll();
}


/*--------------------

---------------------*/
void draw_puts(char *s)
{
  while( *s )
    draw_char( *s++ );
  osWritebackDCacheAll();
}

/*--------------------

---------------------*/
void draw_center(char *s) {
	int i;

	i=((SCREEN_SIZE_X/PATTERN_SIZE_X)-strlen(s))>>1;
	set_xy(i,y_pos);
	draw_puts(s);
}
